unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, mMailer, IdEMailAddress, Registry, ComCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    mMailer1: TmMailer;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Setup1: TMenuItem;
    Button1: TButton;
    CheckBox1: TCheckBox;
    ListBox1: TListBox;
    Label3: TLabel;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    procedure Setup1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure mMailer1Connected(Sender: TObject);
    procedure mMailer1Disconnected(Sender: TObject);
    procedure mMailer1SendError(Sender: TObject; ErrorMsg: String);
  private
    procedure CutOutStrs(Str, DelCh: string; var SStrs: TStringList);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.Setup1Click(Sender: TObject);
var
  Reg: TRegistry;
begin
  Reg:= TRegistry.Create;
  try
    if SetupForm.ShowModal = mrOK then
      with SetupForm do
      begin
        mMailer1.Host:= Edit1.Text;
        mMailer1.UserId:= Edit2.Text;
        mMailer1.Password:= Edit3.Text;
        Reg.RootKey:= HKEY_CURRENT_USER;
        if Reg.OpenKey('\software\mas prod.\TmMailer', true) then
        begin
          Reg.WriteString('Host', Edit1.Text);
          Reg.WriteString('UserId', Edit2.Text);
          Reg.WriteString('Password', Edit3.Text);
        end;
      end;
  finally
    Reg.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  SStrs: TStringList;
  n: Integer;
  RItem: TIdEMailAddressItem;
begin
  SStrs:= TStringList.Create;
  try
    with mMailer1 do
    begin
      From.Address:= Edit1.Text;
      // Get recipients
      CutOutStrs(Edit2.Text, ';', SStrs);
      for n:= 0 to SStrs.Count - 1 do
      begin
        RItem:= Recipients.Add;
        RItem.Address:= Trim(SStrs[n]);
      end;
      Subject:= Edit3.Text;
      Attachments.AttachedFiles.Text:= ListBox1.Items.Text;
      Body.Text:= Memo1.Text;
      HTML:= CheckBox1.Checked;
      Send;
    end;
  finally
    SStrs.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  n: Integer;
begin
  if OpenDialog1.Execute then
    for n:= 0 to OpenDialog1.Files.Count - 1 do
      ListBox1.Items.Add(OpenDialog1.Files[n]);
end;

procedure TForm1.CutOutStrs(Str, DelCh: string; var SStrs: TStringList);
begin
  SStrs.Clear;
  if Pos(DelCh, Str) = 0 then
  begin
    SStrs.Add(Str);
    Exit;
  end;
  while Pos(DelCh, Str) <> 0 do
  begin
    SStrs.Add(Copy(Str, 1, Pos(DelCh, Str) - 1));
    Str:= Copy(Str, Pos(DelCh, Str) + 1, Length(Str));
  end;
  SStrs.Add(Str);
end;

procedure TForm1.mMailer1Connected(Sender: TObject);
begin
  StatusBar1.SimpleText:= '  Connected';
end;

procedure TForm1.mMailer1Disconnected(Sender: TObject);
begin
  StatusBar1.SimpleText:= '  Disconnected';
end;

procedure TForm1.mMailer1SendError(Sender: TObject; ErrorMsg: String);
begin
  StatusBar1.SimpleText:= '  ' + ErrorMsg;
end;

end.

