{-----------------------------------------------------------------------------
 Unit Name: Unit1
 Author:    Mats Asplund
 Purpose:   TmParser component demo
 History:   2003-05-01
-----------------------------------------------------------------------------}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, mParser, StdCtrls, ComCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TextMemo: TMemo;
    LinkMemo: TMemo;
    ImageMemo: TMemo;
    TagMemo: TMemo;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    Bevel1: TBevel;
    mParser1: TmParser;
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure mParser1Tag(Sender: TObject; TagText: String;
      Index: Integer);
    procedure mParser1Text(Sender: TObject; PureText: String;
      Index: Integer);
    procedure mParser1ImageTag(Sender: TObject; ImageTagText: String;
      Index: Integer);
    procedure mParser1LinkTag(Sender: TObject; LinkTagText: String;
      Index: Integer);
  private
    procedure ClearMemos;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Edit1Change(Sender: TObject);
begin
  Button1.Enabled:= true;
  Button2.Enabled:= false;
  Button1.Default:= true;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  Button2.Enabled:= true;
  Button1.Enabled:= false;
  Button2.Default:= true;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    Edit1.Text:= OpenDialog1.FileName;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  mParser1.HTMLFile:= Edit1.Text;
  ClearMemos;
  if not mParser1.Parse then
    MessageDlg('File not found !', mtError, [mbOK], 0);
end;

procedure TForm1.ClearMemos;
begin
  TextMemo.Clear;
  TagMemo.Clear;
  LinkMemo.Clear;
  ImageMemo.Clear;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  mParser1.URI:= Edit2.Text;
  ClearMemos;
  if not mParser1.DownLoadAndParse then
    MessageDlg('File not found !', mtError, [mbOK], 0);
end;

procedure TForm1.mParser1Tag(Sender: TObject; TagText: String;
  Index: Integer);
begin
  TagMemo.Lines.Add(IntToStr(Index) + ': ' + TagText);
end;

procedure TForm1.mParser1Text(Sender: TObject; PureText: String;
  Index: Integer);
begin
  TextMemo.Lines.Add(IntToStr(Index) + ': ' + PureText);
end;

procedure TForm1.mParser1ImageTag(Sender: TObject; ImageTagText: String;
  Index: Integer);
begin
  ImageMemo.Lines.Add(IntToStr(Index) + ': ' + ImageTagText);
end;

procedure TForm1.mParser1LinkTag(Sender: TObject; LinkTagText: String;
  Index: Integer);
begin
  LinkMemo.Lines.Add(IntToStr(Index) + ': ' + LinkTagText);
end;

end.
