{
---------------------------------------------------------------
Code generated by AF Component Wizard
AF Component Wizard 2002 AFComponents - Ferruccio Accalai
Idea by MAS-CompMaker, 2000-2002 Mats Asplund http://go.to/mdp
---------------------------------------------------------------

Component Name: TmLinkCombo
        Author: Mats Asplund
 Creation Date: 2003-07-24
       Version: 1.0
   Description: A combobox component with weblinks.
        E-mail: masprod@telia.com
       Website: http://go.to/masdp
  Legal Issues: All rigths reserved 2003 by Mats Asplund


Usage:
  This software is provided 'as-is', without any express or
  implied warranty.  In no event will the author be held liable
  for any  damages arising from the use of this software.

  Permission is granted to anyone to use this software for any
  purpose, including commercial applications, and to alter it
  and redistribute it freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented,
     you must not claim that you wrote the original software.
     If you use this software in a product, an acknowledgment
     in the product documentation would be appreciated but is
     not required.

  2. Altered source versions must be plainly marked as such, and
     must not be misrepresented as being the original software.

  3. This notice may not be removed or altered from any source
     distribution.

  4. If you decide to use this software in any of your applications.
     Send me an EMail and tell me about it.

Quick Reference:
  TmLinkCombo inherits from TCustomComboBox

  Key-Properties:
    LinkAlias:    A string containing linkaddresses and linkaliases. The
                  linkaddresses are URI:s that will opened when the combo
                  changes state. The linkaliases is what will be shown in the
                  dropdownlist. The LinkAlias string format is:
                  <linkaddress>=<linkalias><cr><lf>.
                  A special editor (LinkAliasEditor.pas), is used for this
                  property, which will make it easy to assign values at
                  designtime.

    JumpLink:     If true, the corresponding linkaddress to the selected
                  linkalias will automatically be opened in the default
                  web browser when the combo changes state.

  Key-Events:
    OnLinkChange: Event fired when combo changes state. Returns Link, LinkAlias
                  and DoJump(var).

---------------------------------------------------------------
}

unit mLinkCombo;

interface

uses
  Windows, Messages, SysUtils, Classes, StdCtrls, Controls;

type
  TLinkAlias = string;

  TOnLinkChangeEvent =
    procedure(Sender: TObject; Link, LinkAlias: string; var DoJump: boolean) of object;

  TmLinkCombo = class(TCustomComboBox)
  private
    fAbout: string;
    fLinkAlias: TLinkAlias;
    fOnLinkChanged: TOnLinkChangeEvent;
    fList: TStringList;
    fJumpLink: boolean;
    procedure LinkComboChange(Sender: TObject);
    function GetLinkAlias: TLinkAlias;
    procedure SetLinkAlias(const Value: TLinkAlias);
    procedure SetAbout(Value: string);
  protected
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Anchors;
    property Enabled;
    property Font;
    property PopupMenu;
    property ShowHint;
    property Sorted;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property LinkAlias: TLinkAlias read GetLinkAlias write SetLinkAlias;
    property JumpLink: boolean read fJumpLink write fJumpLink;
    property OnLinkChange: TOnLinkChangeEvent read fOnLinkChanged
      write fOnLinkChanged;
    property About: string read fAbout write SetAbout;
  end;

procedure Register;

implementation
uses ShellAPI;

procedure Register;
begin
  RegisterComponents('MAs Prod.', [TmLinkCombo]);
end;

constructor TmLinkCombo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fList:= TStringList.Create;
  OnChange:= LinkComboChange;
  fJumpLink:= true;
  fAbout:= 'Version 1.0, 2003  Mats Asplund';
end;

destructor TmLinkCombo.Destroy;
begin
  inherited Destroy;
  fList.Free;
end;

function TmLinkCombo.GetLinkAlias: TLinkAlias;
begin
  Result:= fLinkAlias;
end;

procedure TmLinkCombo.LinkComboChange(Sender: TObject);
var
  Link, LinkAlias: string;
  DoJump: boolean;
begin
  Link:= Copy(fList[ItemIndex], 1, Pos('=', fList[ItemIndex]) -1);
  LinkAlias:= Copy(fList[ItemIndex], Pos('=', fList[ItemIndex]) +1, 1000);
  DoJump:= fJumpLink;
  if Assigned(fOnLinkChanged) then
    fOnLinkChanged(self, Link, LinkAlias, DoJump);
  if DoJump and (Link <> '') then
    ShellExecute(0, 'open', PChar(Link), '', '', SW_SHOWNORMAL);
end;

procedure TmLinkCombo.SetAbout(Value: string);
begin
  Exit;
end;

procedure TmLinkCombo.SetLinkAlias(const Value: TLinkAlias);
var
  n: integer;
begin
  fLinkAlias:= Value;
  fList.Text:= fLinkAlias;
  Items.Clear;
  for n:= 0 to fList.Count -1 do
    Items.Add(Copy(fList[n], Pos('=', fList[n]) +1, 1000));
end;

end.

